/**
 * ASM examples: examples showing how ASM can be use
 * Copyright (c) 2000-2007 INRIA, France Teleco
 * All rights reserved
 
 * Redistribution and use in source and binary forms, with or withou
 * modification, are permitted provided that the following condition
 * are met
 * 1. Redistributions of source code must retain the above copyrigh
 *    notice, this list of conditions and the following disclaimer
 * 2. Redistributions in binary form must reproduce the above copyrigh
 *    notice, this list of conditions and the following disclaimer in th
 *    documentation and/or other materials provided with the distribution
 * 3. Neither the name of the copyright holders nor the names of it
 *    contributors may be used to endorse or promote products derived fro
 *    this software without specific prior written permission
 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, TH
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOS
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS B
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, O
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT O
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINES
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER I
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED O
 * THE POSSIBILITY OF SUCH DAMAGE
 *
import org.objectweb.asm.ClassWriter
import org.objectweb.asm.MethodVisitor
import org.objectweb.asm.Opcodes
import org.objectweb.asm.Type
import org.objectweb.asm.commons.GeneratorAdapter
import org.objectweb.asm.commons.Method

import java.io.FileOutputStream
import java.io.PrintStream

/*
 * @author Eric Bruneto
 *
public class Helloworld extends ClassLoader implements Opcodes 

    public static void main(final String args[]) throws Exception 

        // Generates the bytecode corresponding to the following Java class
        //
        // public class Example 
        // public static void main (String[] args) 
        // System.out.println("Hello world!")
        // 
        // 

        // creates a ClassWriter for the Example public class
        // which inherits from Objec
        ClassWriter cw = new ClassWriter(0)
        cw.visit(V1_1, ACC_PUBLIC, "Example", null, "java/lang/Object", null)

        // creates a MethodWriter for the (implicit) constructo
        MethodVisitor mw = cw.visitMethod(ACC_PUBLIC
                "<init>"
                "()V"
                null
                null)
        // pushes the 'this' variabl
        mw.visitVarInsn(ALOAD, 0)
        // invokes the super class constructo
        mw.visitMethodInsn(INVOKESPECIAL, "java/lang/Object", "<init>", "()V")
        mw.visitInsn(RETURN)
        // this code uses a maximum of one stack element and one local variabl
        mw.visitMaxs(1, 1)
        mw.visitEnd()

        // creates a MethodWriter for the 'main' metho
        mw = cw.visitMethod(ACC_PUBLIC + ACC_STATIC
                "main"
                "([Ljava/lang/String;)V"
                null
                null)
        // pushes the 'out' field (of type PrintStream) of the System clas
        mw.visitFieldInsn(GETSTATIC
                "java/lang/System"
                "out"
                "Ljava/io/PrintStream;")
        // pushes the "Hello World!" String constan
        mw.visitLdcInsn("Hello world!")
        // invokes the 'println' method (defined in the PrintStream class
        mw.visitMethodInsn(INVOKEVIRTUAL
                "java/io/PrintStream"
                "println"
                "(Ljava/lang/String;)V")
        mw.visitInsn(RETURN)
        // this code uses a maximum of two stack elements and two loca
        // variable
        mw.visitMaxs(2, 2)
        mw.visitEnd()

        // gets the bytecode of the Example class, and loads it dynamicall
        byte[] code = cw.toByteArray()

        FileOutputStream fos = new FileOutputStream("Example.class")
        fos.write(code)
        fos.close()

        Helloworld loader = new Helloworld()
        Class exampleClass = loader.defineClass("Example", code, 0, code.length)

        // uses the dynamically generated class to print 'Helloworld
        exampleClass.getMethods()[0].invoke(null, new Object[] { null })

        // -----------------------------------------------------------------------
        // Same example with a GeneratorAdapter (more convenient but slower
        // -----------------------------------------------------------------------

        cw = new ClassWriter(ClassWriter.COMPUTE_MAXS)
        cw.visit(V1_1, ACC_PUBLIC, "Example", null, "java/lang/Object", null)

        // creates a GeneratorAdapter for the (implicit) constructo
        Method m = Method.getMethod("void <init> ()")
        GeneratorAdapter mg = new GeneratorAdapter(ACC_PUBLIC
                m
                null
                null
                cw)
        mg.loadThis()
        mg.invokeConstructor(Type.getType(Object.class), m)
        mg.returnValue()
        mg.endMethod()

        // creates a GeneratorAdapter for the 'main' metho
        m = Method.getMethod("void main (String[])")
        mg = new GeneratorAdapter(ACC_PUBLIC + ACC_STATIC, m, null, null, cw)
        mg.getStatic(Type.getType(System.class)
                "out"
                Type.getType(PrintStream.class))
        mg.push("Hello world!")
        mg.invokeVirtual(Type.getType(PrintStream.class)
                Method.getMethod("void println (String)"))
        mg.returnValue()
        mg.endMethod()

        cw.visitEnd()

        code = cw.toByteArray()
        loader = new Helloworld()
        exampleClass = loader.defineClass("Example", code, 0, code.length)

        // uses the dynamically generated class to print 'Helloworld
        exampleClass.getMethods()[0].invoke(null, new Object[] { null })
    

