<?xml version="1.0" encoding="ASCII"?
<!-
  ASM XML Adapter examples
  Copyright (c) 2004, Eugene Kulesho
  All rights reserved

  Redistribution and use in source and binary forms, with or withou
  modification, are permitted provided that the following condition
  are met
  1. Redistributions of source code must retain the above copyrigh
     notice, this list of conditions and the following disclaimer
  2. Redistributions in binary form must reproduce the above copyrigh
     notice, this list of conditions and the following disclaimer in th
     documentation and/or other materials provided with the distribution
  3. Neither the name of the copyright holders nor the names of it
     contributors may be used to endorse or promote products derived fro
     this software without specific prior written permission

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, TH
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOS
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS B
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, O
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT O
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINES
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER I
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED O
  THE POSSIBILITY OF SUCH DAMAGE
--

<!-
  XSL transformation for ASM XML document to add the code that will dum
  an execution time for each method
--

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
<xsl:output method="xml" indent="yes" encoding="ASCII"/


<xsl:template match="//method/code"
  <code
    <!-- add attributes for code element --
    <xsl:apply-templates select="@*"/
 
    <!-- store start time into the max variable after method params --
    <INVOKESTATIC desc="()J" name="currentTimeMillis" owner="java/lang/System"/
    <LSTORE
      <xsl:attribute name="var"
        <xsl:value-of select="./Max/@maxLocals"/
      </xsl:attribute
    </LSTORE

    <!-- process child elements --
    <xsl:apply-templates select="*"/

  </code

</xsl:template


<!-
  Add print statement before return instruction
  IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN,
  ATHROW ?
--
<xsl:template match="//IRETURN | //LRETURN | //FRETURN | //DRETURN | //ARETURN | //RETURN"
  <GETSTATIC desc="Ljava/io/PrintStream;" name="err" owner="java/lang/System"/

  <NEW desc="java/lang/StringBuffer"/
  <DUP/
  <INVOKESPECIAL owner="java/lang/StringBuffer" name="&lt;init&gt;" desc="()V"/
 
  <INVOKESTATIC desc="()J" name="currentTimeMillis" owner="java/lang/System"/
  <LLOAD
    <xsl:attribute name="var"
      <xsl:value-of select="../Max/@maxLocals"/
    </xsl:attribute
  </LLOAD
  <LSUB/
  <INVOKEVIRTUAL owner="java/lang/StringBuffer" name="append" desc="(J)Ljava/lang/StringBuffer;"/
 
  <LDC desc="Ljava/lang/String;"
    <xsl:attribute name="cst"
      <xsl:value-of select="concat( ' : ', ../../../@name, '.', ../../@name, ../../@desc)"/
    </xsl:attribute
  </LDC
  <INVOKEVIRTUAL owner="java/lang/StringBuffer" name="append" desc="(Ljava/lang/String;)Ljava/lang/StringBuffer;"/
  <INVOKEVIRTUAL owner="java/lang/StringBuffer" name="toString" desc="()Ljava/lang/String;"/

  <INVOKEVIRTUAL desc="(Ljava/lang/String;)V" name="println" owner="java/io/PrintStream"/

  <xsl:element name="{name()}"/
</xsl:template


<!-- copy everything --
<xsl:template match="@*|*|text()|processing-instruction()"
  <xsl:copy><xsl:apply-templates select="@*|*|text()|processing-instruction()"/></xsl:copy
</xsl:template

</xsl:stylesheet

